<template>
  <form class="form" @submit="submit">
    <slot />
  </form>
</template>

<script lang="ts" setup>
import { useForm } from 'vee-validate'

const emit = defineEmits(['submit'])

const props = defineProps({
  form: {
    type: [Object as any],
    required: false,
    default: false
  }
})

const form = props.form ? props.form : useForm()

provide('form', form)

const submit = (e: Event) => {
  e.preventDefault()
  emit('submit', e, form)
}
</script>
